package com.muyu.system.service.impl;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.DateUtils;
import com.muyu.system.domain.AsUserDept;
import com.muyu.system.domain.resp.AsUserDeptNumResponse;
import com.muyu.system.mapper.AsUserDeptMapper;
import com.muyu.system.service.IAsUserDeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Project：cloud-server
 * @User：86152
 * @Author：Mr.Huang
 * @Description:
 * @Date：2024-04-14 09:38
 * @Package：com.muyu.system.service.impl
 */
@Service
public class AsUserDeptServiceImpl implements IAsUserDeptService {

    @Autowired
    private AsUserDeptMapper asUserDeptMapper;

    @Override
    public AsUserDept selectAsUserDeptById(Long id) {
        return asUserDeptMapper.selectAsUserDeptById(id);
    }

    @Override
    public List<AsUserDept> selectAsUserDeptList(AsUserDept asUserDept) {
        return asUserDeptMapper.selectAsUserDeptList(asUserDept);
    }

    @Override
    public int insertAsUserDept(AsUserDept asUserDept) {
        asUserDept.setCreateTime(DateUtils.getNowDate());
        return asUserDeptMapper.insertAsUserDept(asUserDept);
    }

    @Override
    public int updateAsUserDept(AsUserDept asUserDept) {
        asUserDept.setUpdateTime(DateUtils.getNowDate());
        return asUserDeptMapper.updateAsUserDept(asUserDept);
    }

    @Override
    public int deleteAsUserDeptByIds(Long[] ids) {
        return asUserDeptMapper.deleteAsUserDeptByIds(ids);
    }

    @Override
    public int deleteAsUserDeptById(Long id) {
        return asUserDeptMapper.deleteAsUserDeptById(id);
    }

    @Override
    public Result updateAsUserDeptRead(Long id) {
        asUserDeptMapper.updateAsUserDeptRead(id);
        return Result.success();
    }

    @Override
    public Result<AsUserDeptNumResponse> getNum(Long noticeId) {
        Long num = asUserDeptMapper.selectAsUserDeptNum(noticeId);
        Long readNum = asUserDeptMapper.selectAsUserDeptReadNum(noticeId);
        long noReadNum = num - readNum;
        return Result.success(AsUserDeptNumResponse.builder()
                .num(num)
                .readNum(readNum)
                .noReadNum(noReadNum)
                .build());
    }
}
